<?php

namespace Teknisa\MAN\Controllers;
use Zeedhi\Framework\DataSource\FilterCriteria; 
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DTO;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\MAN\Utilities;
use \Setforms2\Shared\ORM\DateTime;
use Teknisa\MAN\Utilities\DateUtil;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use \Teknisa\Libs\Utilities\Environment;
use \Zeedhi\Framework\DTO\Request\Row;

class ControleRoyalt extends \Teknisa\MAN\Controllers\TeknisaCrud {
    

    protected $dataSourceName = 'cadBeneficio';
    protected $parameterBagColumns = array('NRORG');

    public function __construct ( ParameterBag $parameterBag, Manager $dataSourceManager,Utilities\Util $utilService, EntityManager $entityManager, $crudService   ) {
        $this->dataSourceManager = $dataSourceManager;
	    $this->parameterBag = $parameterBag;
	    $this->crudService =$crudService;
        $this->utilService = $utilService;
        $this->entityManager = $entityManager;

    }
    
    public function findRoyalt(DTO\Request\Filter $request, DTO\Response $response){
        $ARRAYFINAL = [];
        $params = $this->utilService->getParamsAsArray($request);
        
        if(isset($params["CDFILIALFRANQUIADA"])){
            ///Pega os dados das filias
            $result = $this->getparavend($params);
            ///pega o produto que sera acrecentado na nota
            // $adqProdutoNota = $this->adqProdutoNota($params);
        
            foreach ($result as $key => $value){
                ///TRATATIVAS DATAS///
                $datafechamento = $value["DTFECHAFRANQ"].'/'.$params["DATAINI"];
                $DTFIMPERTAXA = $datafinal=$this->validarData($datafechamento);
                list($dia, $mes, $ano) = explode('/', $DTFIMPERTAXA);
                $DIAVENCNF = $dia;
                //Data Inicial
                $DTINIPERTAXA = $this->mesAnterior($datafechamento);
                
                ///Obtem valor total do Faturamento Bruto///
                $VRFATBRUTO = $this->getfaturamentobruto($DTFIMPERTAXA, $DTINIPERTAXA, $value["CDFILIAL"]);
                
                ////Aloca os dados fornecidos pelo usuario para serem retornados e usados na apuraçao posteriomente.
                $value['DTFIMPERTAXA']  = $DTFIMPERTAXA;
                $value['DIAVENCNF']     = $DIAVENCNF;
                $value['DTINIPERTAXA']  = $DTINIPERTAXA;
                $value["DTFECHAFRANQ"]  = $DTFIMPERTAXA;
                $value['VRFATBRUTO']    = $VRFATBRUTO[0]["TOTAL"];
                    
                ////Obtem o valor das filiais ja apuradas e determinada data
                $resultmovfrank = $this->getmovtofrank($DTFIMPERTAXA, $DTINIPERTAXA, $value["CDFILIAL"]);
                if($resultmovfrank){
                $resultmovfrank = $resultmovfrank[0];
                }
                
                ////VERIFICA SE O A FILIAL JA TEM ALGUM DADO APURADO NA DATA ESPECIFICADA CASO JA TENHA ELE TRAS ESSES DADOS//    
                    
                $arraypronto["IDCHECK"]          = isset($resultmovfrank["IDCHECK"]) ? $resultmovfrank["IDCHECK"] : (isset($value["IDCHECK"]) ? $value["IDCHECK"] : null);
                $arraypronto["IDSITUNOTA"]       = isset($resultmovfrank["IDSITUNOTA"]) ? $resultmovfrank["IDSITUNOTA"] : (isset($value["IDSITUNOTA"]) ? $value["IDSITUNOTA"] : null);
                $arraypronto["CDFILIAL"]         = isset($resultmovfrank["CDFILIAL"]) ? $resultmovfrank["CDFILIAL"] : (isset($value["CDFILIAL"]) ? $value["CDFILIAL"] : null);
                $arraypronto["NMFILIAL"]         = isset($resultmovfrank["NMFILIAL"]) ? $resultmovfrank["NMFILIAL"] : (isset($value["NMFILIAL"]) ? $value["NMFILIAL"] : null);
                $arraypronto["FILIAL"]           = $arraypronto["CDFILIAL"].' - '.$arraypronto["NMFILIAL"];
                $arraypronto["IDTPTAXAROYA"]     = isset($resultmovfrank["IDTPTAXAROYA"]) ? $resultmovfrank["IDTPTAXAROYA"] : (isset($value["IDTPTAXAROYA"]) ? $value["IDTPTAXAROYA"] : null);
                $arraypronto["IDTPTAXAMARK"]     = isset($resultmovfrank["IDTPTAXAMARK"]) ? $resultmovfrank["IDTPTAXAMARK"] : (isset($value["IDTPTAXAMARK"]) ? $value["IDTPTAXAMARK"] : null);
                $arraypronto["DTFECHAFRANQ"]     = isset($resultmovfrank["DTFECHAFRANQ"]) ? $resultmovfrank["DTFECHAFRANQ"] : (isset($value["DTFECHAFRANQ"]) ? $value["DTFECHAFRANQ"] : null);
                $arraypronto["VRPERCROYALT"]     = isset($resultmovfrank["VRPERCROYALT"]) ? $resultmovfrank["VRPERCROYALT"] : (isset($value["VRPERCROYALT"]) ? $value["VRPERCROYALT"] : null);
                $arraypronto["VRFIXOROYALT"]     = isset($resultmovfrank["VRFIXOROYALT"]) ? $resultmovfrank["VRFIXOROYALT"] : (isset($value["VRFIXOROYALT"]) ? $value["VRFIXOROYALT"] : null);
                $arraypronto["VRPERCMARKET"]     = isset($resultmovfrank["VRPERCMARKET"]) ? $resultmovfrank["VRPERCMARKET"] : (isset($value["VRPERCMARKET"]) ? $value["VRPERCMARKET"] : null);
                $arraypronto["VRFIXOMARKET"]     = isset($resultmovfrank["VRFIXOMARKET"]) ? $resultmovfrank["VRFIXOMARKET"] : (isset($value["VRFIXOMARKET"]) ? $value["VRFIXOMARKET"] : null);
                $arraypronto["TPVENCNF"]         = isset($resultmovfrank["TPVENCNF"]) ? $resultmovfrank["TPVENCNF"] : (isset($value["TPVENCNF"]) ? $value["TPVENCNF"] : null);
                $arraypronto["DIAVENCNF"]        = isset($resultmovfrank["DIAVENCNF"]) ? $resultmovfrank["DIAVENCNF"] : (isset($value["DIAVENCNF"]) ? $value["DIAVENCNF"] : null);
                $arraypronto["CDCLIFRAN"]        = isset($resultmovfrank["CDCLIFRAN"]) ? $resultmovfrank["CDCLIFRAN"] : (isset($value["CDCLIFRAN"]) ? $value["CDCLIFRAN"] : null);
                $arraypronto["NMRAZSOCCLIEFRAN"] = isset($resultmovfrank["NMRAZSOCCLIEFRAN"]) ? $resultmovfrank["NMRAZSOCCLIEFRAN"] : (isset($value["NMRAZSOCCLIEFRAN"]) ? $value["NMRAZSOCCLIEFRAN"] : null);
                $arraypronto["DTFIMPERTAXA"]     = isset($resultmovfrank["DTFIMPERTAXA"]) ? $resultmovfrank["DTFIMPERTAXA"] : (isset($value["DTFIMPERTAXA"]) ? $value["DTFIMPERTAXA"] : null);
                $arraypronto["DTINIPERTAXA"]     = isset($resultmovfrank["DTINIPERTAXA"]) ? $resultmovfrank["DTINIPERTAXA"] : (isset($value["DTINIPERTAXA"]) ? $value["DTINIPERTAXA"] : null);
                $arraypronto["VRFATBRUTO"]       = isset($resultmovfrank["VRFATBRUTO"]) ? $resultmovfrank["VRFATBRUTO"] : (isset($value["VRFATBRUTO"]) ? $value["VRFATBRUTO"] : null);
                $arraypronto["CDFILIALFRAN"]     = isset($resultmovfrank["CDFILIALFRAN"]) ? $resultmovfrank["CDFILIALFRAN"] : (isset($value["CDFILIALFRAN"]) ? $value["CDFILIALFRAN"] : null);
                $arraypronto["NMFILIALFRAN"]     = isset($resultmovfrank["NMFILIALFRAN"]) ? $resultmovfrank["NMFILIALFRAN"] : (isset($value["NMFILIALFRAN"]) ? $value["NMFILIALFRAN"] : null);
                $arraypronto["NRLANCTONFMARK"]   = isset($resultmovfrank["NRLANCTONFMARK"]) ? $resultmovfrank["NRLANCTONFMARK"] : (isset($value["NRLANCTONFMARK"]) ? $value["NRLANCTONFMARK"] : null);
                $arraypronto["VRNOTAMARKET"]     = isset($resultmovfrank["VRNOTAMARKET"]) ? $resultmovfrank["VRNOTAMARKET"] : (isset($value["VRNOTAMARKET"]) ? $value["VRNOTAMARKET"] : null);
                $arraypronto["VRBOLEROYALT"]     = isset($resultmovfrank["VRBOLEROYALT"]) ? $resultmovfrank["VRBOLEROYALT"] : (isset($value["VRBOLEROYALT"]) ? $value["VRBOLEROYALT"] : null);
                $arraypronto["DTVENCTONF"]       = isset($resultmovfrank["DTVENCTONF"]) ? $resultmovfrank["DTVENCTONF"] : (isset($value["DTVENCTONF"]) ? $value["DTVENCTONF"] : null);
                $arraypronto["DTHRAPURTAXA"]     = isset($resultmovfrank["DTHRAPURTAXA"]) ? $resultmovfrank["DTHRAPURTAXA"] : (isset($value["DTHRAPURTAXA"]) ? $value["DTHRAPURTAXA"] : null);
                $arraypronto["DTHRGERANF"]       = isset($resultmovfrank["DTHRGERANF"]) ? $resultmovfrank["DTHRGERANF"] : (isset($value["DTHRGERANF"]) ? $value["DTHRGERANF"] : null);
                $arraypronto["CDFILIALNF"]       = isset($resultmovfrank["CDFILIALNF"]) ? $resultmovfrank["CDFILIALNF"] : (isset($value["CDFILIALNF"]) ? $value["CDFILIALNF"] : null);
                $arraypronto["NRLANCTONFROYA"]   = isset($resultmovfrank["NRLANCTONFROYA"]) ? $resultmovfrank["NRLANCTONFROYA"] : (isset($value["NRLANCTONFROYA"]) ? $value["NRLANCTONFROYA"] : null);
                $arraypronto["NRORG"]            = isset($resultmovfrank["NRORG"]) ? $resultmovfrank["NRORG"] : (isset($value["NRORG"]) ? $value["NRORG"] : null);
                $arraypronto["IDATIVO"]          = isset($resultmovfrank["IDATIVO"]) ? $resultmovfrank["IDATIVO"] : (isset($value["IDATIVO"]) ? $value["IDATIVO"] : null);
                $arraypronto["DTINCLUSAO"]       = isset($resultmovfrank["DTINCLUSAO"]) ? $resultmovfrank["DTINCLUSAO"] : (isset($value["DTINCLUSAO"]) ? $value["DTINCLUSAO"] : null);
                $arraypronto["NRORGINCLUSAO"]    = isset($resultmovfrank["NRORGINCLUSAO"]) ? $resultmovfrank["NRORGINCLUSAO"] : (isset($value["NRORGINCLUSAO"]) ? $value["NRORGINCLUSAO"] : null);
                $arraypronto["CDOPERINCLUSAO"]   = isset($resultmovfrank["CDOPERINCLUSAO"]) ? $resultmovfrank["CDOPERINCLUSAO"] : (isset($value["CDOPERINCLUSAO"]) ? $value["CDOPERINCLUSAO"] : null);
                $arraypronto["NRORGULTATU"]      = isset($resultmovfrank["NRORGULTATU"]) ? $resultmovfrank["NRORGULTATU"] : (isset($value["NRORGULTATU"]) ? $value["NRORGULTATU"] : null);
                $arraypronto["CDOPERULTATU"]     = isset($resultmovfrank["CDOPERULTATU"]) ? $resultmovfrank["CDOPERULTATU"] : (isset($value["CDOPERULTATU"]) ? $value["CDOPERULTATU"] : null);
                $arraypronto["IDVIAIMPORTACAO"]  = isset($resultmovfrank["IDVIAIMPORTACAO"]) ? $resultmovfrank["IDVIAIMPORTACAO"] : (isset($value["IDVIAIMPORTACAO"]) ? $value["IDVIAIMPORTACAO"] : null);
    
            ///Array de dados final
                $ARRAYFINAL[]= $arraypronto;
            }

            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('FindRoyalt', $ARRAYFINAL));
        }
        
    }
    
    public function ApurarRoyalt(Request\Row $request, Response $response){
        $row = $request->getRow();

        foreach ($row as $key => $value){
            ///Calculo Das Taxas///
            if ($value['IDTPTAXAROYA'] == '2') {
                $value['VRBOLEROYALT'] = round(($value['VRPERCROYALT'] * $value['VRFATBRUTO']) / 100, 2);
            } else {
                $value['VRBOLEROYALT'] = $value['VRFIXOROYALT'];
            }
                
            if ($value['IDTPTAXAMARK'] == '2') {
                $value['VRNOTAMARKET'] = round(($value['VRPERCMARKET'] * $value['VRFATBRUTO']) / 100, 2);
            } else {
                $value['VRNOTAMARKET'] = $value['VRFIXOMARKET'];
            }
            ///Calculo Datas finais///
            $value['DTHRAPURTAXA']=$dataAtual = date('d/m/Y');
            
           
            $value['DTFIMPERTAXA'] = substr($value['DTFIMPERTAXA'], 0, 10);
            $date = date_create_from_format('d/m/Y', $value['DTFIMPERTAXA']);
           
            $dtDataFim = $date->format('Y-m-d');
            if ($value['TPVENCNF'] == '1') {
                $dtDataVenc = date('Y-m-d',strtotime($dtDataFim.'+1 month'));
                $inDiaVenc = (int) $value['DIAVENCNF'];
                $inUltimoDia = date('t', strtotime($dtDataVenc));
                            
                if ($inUltimoDia < $inDiaVenc) {
                    $dtDataVenc = date('d/m/Y', strtotime($inUltimoDia . date("-m-Y", strtotime($dtDataVenc))));
                } else {
                    $dtDataVenc = date('d/m/Y', strtotime($inDiaVenc . date("-m-Y", strtotime($dtDataVenc))));
                }
                
            } else {
                $dtDataVenc = date('d/m/Y', strtotime($dtDataFim . ' +' . $value['DIAVENCNF'] . ' days'));
            }
            
            ////Reservado para Geraçao NFC//
            $value['DTHRGERANF'] = null;
            
            $params = array (
                ':NMRAZSOCCLIEFRAN'=>$value['NMRAZSOCCLIEFRAN'],
                ':NMFILIALFRAN'     => $value['NMFILIAL'],
                ':IDTPTAXAROYA'     => $value['IDTPTAXAROYA'],
                ':IDTPTAXAMARK'     => $value['IDTPTAXAMARK'],
                ':IDSITUNOTA'       => 'A',
                ':DTINIPERTAXA'     => $value['DTINIPERTAXA'],
                ':DTFIMPERTAXA'     => $value['DTFIMPERTAXA'],
                ':VRFATBRUTO'       => $value['VRFATBRUTO'],
                ':VRPERCROYALT'     => $value['VRPERCROYALT'],
                ':VRFIXOROYALT'     => $value['VRFIXOROYALT'],
                ':VRBOLEROYALT'     => $value['VRBOLEROYALT'],
                ':VRPERCMARKET'     => $value['VRPERCMARKET'],
                ':VRFIXOMARKET'     => $value['VRFIXOMARKET'],
                ':VRNOTAMARKET'     => $value['VRNOTAMARKET'],
                ':DTVENCTONF'       => $dtDataVenc,
                ':DTHRAPURTAXA'     => $value['DTHRAPURTAXA'],
                ':DTHRGERANF'       => $value['DTHRGERANF'],
                ':IDVIAIMPORTACAO'  => 'N',
                ':CDFILIALFRAN'     => $value['CDFILIAL'],
                ':DTFECHAFRANQ'     => $value['DTFECHAFRANQ']
            );
                
            if($value['IDSITUNOTA'] == 'P'){
                $params['CDCLIFRAN'] = $value['CDCLIFRAN'];
                $this->entityManager->getConnection()->executeQuery(self::cdsMovToFranqInsert, $params);
            } else {
                $this->entityManager->getConnection()->executeQuery(self::cdsMovToFranqEdit, $params);
            }
        }
        $response->addNotification(new Notification("Notas Apuradas com sucesso!", Notification::TYPE_SUCCESS));
    }
    
   
    
    public function IniciarTrasmissaoRoyalt(Request\Row $request, Response $response){
        //$params = $this->utilService->getParamsAsArray($request);
        $UnidadesErros = array();
        $row = $request->getRow();
            foreach ($row as $key => $value){
            try{
                 ////Usado na requisiçao de erro
                    $unidadeerro = $value["CDFILIAL"];
                ////Fim///
                    
                    ///pega as infomraçoes da filial
                    $infoFilial = $this->getInfosByFilial($value);
                    $adqFilia = $this->adqFilial($value);
                    ////Fim////
                    ////pega as informaçoes da filial franqueadora
                    $adqProdutoNota = $this->adqProdutoNota($value);
                    $value['CDEMPRESA'] = $infoFilial["CDEMPRESA"];
                    $value['CDINSCESTA'] = $infoFilial["CDINSCESTA"];
                    ///////Fim///
                    
                
                //Gera Nota Fiscal Royalt
                if ($value['IDTPTAXAROYA'] != '1' && empty($value['NRLANCTONFROYA']) && $value['VRBOLEROYALT']>0) {
                    $flag=true;
                    
                    ///Gera o numero sequencial////
                    $stNrLanctoNF = $this->NOVO_CODIGO($value,$adqProdutoNota);
                    ///Fim///
                    
                    ////Monta o corpo da nota////
                    $NotaFiscal = $this->Gera_NotaFiscal_Corpo($value,$adqProdutoNota,$stNrLanctoNF);
                    
                    $Gera_NotaFiscal_Produto = $this->Gera_NotaFiscal_Produto($value,$NotaFiscal,$adqProdutoNota,$flag);
                    
                    $Fecha_NotaFiscal_VND = $this->GERA_NOTAFISCAL_FECHAMENTO($value,$NotaFiscal);
                    
                    $GeraDadosFinanceiro = $this->GERA_DADOS_FINANCEIRO($value,$NotaFiscal,$stNrLanctoNF);
                    
                    $acmUpdNotaFiscalRoy = $this->acmUpdNotaFiscalRoy($value,$stNrLanctoNF);

                    $acmUpdContaReceber = $this->acmUpdContaReceber($value,$stNrLanctoNF);
               }
               //Gera Nota Fiscal Marketing
                if ($value['IDTPTAXAMARK'] != '1' && empty($value['NRLANCTONFMARK']) && $value['VRNOTAMARKET']>0) {
                    $flag=false;
                    
                    $stNrLanctoNF = $this->NOVO_CODIGO($value,$adqProdutoNota);

                    $NotaFiscal = $this->Gera_NotaFiscal_Corpo($value,$adqProdutoNota,$stNrLanctoNF);
                    
                    $Gera_NotaFiscal_Produto = $this->Gera_NotaFiscal_Produto($value,$NotaFiscal,$adqProdutoNota,$flag);
                    
                    $Fecha_NotaFiscal_VND = $this->GERA_NOTAFISCAL_FECHAMENTO($value,$NotaFiscal);
                    
                    $acmUpdNotaFiscalMar = $this->acmUpdNotaFiscalMar($value,$stNrLanctoNF);
                    
                    $acmUpdContaReceber = $this->acmUpdContaReceber($value,$stNrLanctoNF);
                }
                
            }catch (\Exception $e){
                array_push($UnidadesErros, $unidadeerro);
                $mensagemerro = "Notas Geradas com sucesso, Foram desconsideras da geração por falta de parametrização as unidades: ";
                foreach ($UnidadesErros as $unidade) {
                    $mensagemerro .= $unidade . ', ';
                }
                $mensagemerro = rtrim($mensagemerro, ', ');
            }    
        }
        
        if(count($UnidadesErros)>0){
            $response->setError(new DTO\Response\Error($mensagemerro, $e->getCode()));    
        }else{
            $response->addNotification(new Notification("Notas Geradas com sucesso!", Notification::TYPE_SUCCESS));
        }
    }
    
    
     public function CancelamentoRoyalt(Request\Row $request, Response $response){
        //$params = $this->utilService->getParamsAsArray($request);
        try{
            $row = $request->getRow();
            $arsParametros='I';
            $stCdProduto=null;
            foreach ($row as $key => $value){
                if($value["FLAGCANCELAMENTO"] == 'ROYALT'){
                    $value['NRLANCTONFROYA'] = $value['NRLANCTONFROYA'];
                }else{
                    $value['NRLANCTONFROYA'] = $value['NRLANCTONFMARK'];
                }
                
                if($arsParametros=='I'){
                
                     $result = $this->adqNotaFiscal($value);
                     if(!empty($result)){
                         $adqNotaFiscal=$result[0];
                     }else{
                         $adqNotaFiscal['IDORIGDESTNF']=null;
                     }
                    
                    
                     
                     $result = $this->adqParamGeral($value);
                     if(!empty($result)){
                         $adqParamGeral=$result[0];
                     }else{
                         $adqParamGeral['IDPERMRELPRAFNF']=null;
                     }
                     
                     if($adqNotaFiscal['IDORIGDESTNF'] == 'F'){
                         
                        $result = $this->adqItensNF($value);
                        if($result){
                            $adqItensNF=$result[0];
                            $dbQtitemprod = 0;
                            $stItemNF = 'N';
                            if ($adqNotaFiscal['IDNFGERADAVIAXML']== 'S' || ($adqNotaFiscal['IDNFGERADAVIAXML'] == 'N' && $adqParamGeral['IDPERMRELPRAFNF'] == 'S')) {
                                $adqItemProdAF = $this->adqItemProdAF($value,$adqItensNF);
        
                                if (empty($adqItemProdAF)){
                                    $adqItemProdAFXML = $this->adqItemProdAFXML($value,$adqItensNF);
                                    if (!empty($adqItemProdAFXML)) {
                                        if ($adqItemProdAFXML[0]['CDPRODUTOAF'] != $adqItemProdAFXML[0]['CDPRODUTONF']) {
                                            if ($adqItemProdAFXML[0]['CDPRODESTOAF'] == $adqItemProdAFXML[0]['CDPRODESTONF']) {
                                                $dbQtitemprod = $adqItensNF['QTITEMPROD'] * $adqItemProdAFXML[0]['VRFATOCONVNF'];
                                                $dbQtitemprod = $dbQtitemprod / $adqItemProdAFXML[0]['VRFATOCONVAF'];
                                                $stCdProduto = $adqItemProdAFXML[0]['CDPRODUTOAF'];
                                                $stItemNF = 'N';
                                            }
                                        }
                                    }
                                } else {
                                    if ($adqItemProdAF[0]['VRFATCONTRIBXML']!= null) {
                                        $dbQtitemprod = $adqItemProdAF[0]['QTITEMPROD'];
                                        $stItemNF = 'S';
                                    }
                                }
                            }
                            
                                if (isset($adqItemProdAFXML[0])) {
                                    $this->NF_BAIXA_AF($value, $adqItensNF, $stItemNF, $dbQtitemprod, $adqItemProdAFXML[0], $stCdProduto);
                                } else {
                                    $this->NF_BAIXA_AF($value, $adqItensNF, $stItemNF, $dbQtitemprod, null, $stCdProduto);
                                }
                            
                        }
                     }
                }
            
                $this->DELETA_NF($value,'I');
                $this->DELETA_NF($value,'C');
                
                if ($value["FLAGCANCELAMENTO"] == 'ROYALT') {
                   $this->acmDelNotaFiscalRoy($value);
                } else {
                   $this->acmDelNotaFiscalMar($value);
                }
            }
        } catch (\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }

    }
    
    
    function validarData ($data) {
      // Separa a string em dia, mês e ano
        list($dia, $mes, $ano) = explode('/', $data);
    
      // Obtém o último dia do mês informado
        $ultimoDia = date('t', strtotime("$ano-$mes-01"));
    
      // Converte as strings em valores numéricos
        $dia = (int) $dia;
        $mes = (int) $mes;
        $ano = (int) $ano;
    
      // Se o dia for maior que o último dia do mês, ajusta para o último dia
        if ($dia > $ultimoDia) {
            $dia = $ultimoDia;
        }
    
      // Retorna a data validada como uma string no formato 'd/m/Y'
        return sprintf('%02d/%02d/%04d', $dia, $mes, $ano);
    }
    
    function mesAnterior($data) {
      // Converte a string em um objeto DateTime
        $dataObj = DateTime::createFromFormat('d/m/Y', $data);
    
      // Subtrai um mês da data
        $dataObj->modify('-1 month');
    
      // Retorna a nova data como uma string no formato 'd/m/Y'
        return $dataObj->format('d/m/Y');
    }
    
    private function adqItemProdAFXML($param,$adqItensNF) {
		$params = array
		( ':P_CDFILIAL'     => $param['CDFILIALPROC'],
		  ':P_NRLANCTONF'   => $param['NRLANCTONFROYA'],
		  ':P_CDPRODUTO'    => $adqItensNF['CDPRODUTO']
		
		);
		$result = $this->entityManager->getConnection()->fetchAll(self::adqItemProdAFXML, $params);
		return($result);
	}
    
    private function adqItemProdAF($param,$adqItensNF) {
		$params = array
		( ':P_CDFILIAL'     => $param['CDFILIALPROC'],
		  ':P_NRLANCTONF'   => $param['NRLANCTONFROYA'],
		  ':P_CDPRODUTO'    => $adqItensNF['CDPRODUTO']
		
		);
		$result = $this->entityManager->getConnection()->fetchAll(self::adqItemProdAF, $params);
		return($result);
	}
    
    private function adqItensNF($param) {
		$params = array (
		    ':P_CDFILIAL'     => $param['CDFILIALPROC'],
		    ':P_NRLANCTONF'   => $param['NRLANCTONFROYA']
		);
		$result = $this->entityManager->getConnection()->fetchAll(self::adqItensNF, $params);
		return($result);
	}
    
    private function adqNotaFiscal($param) {
		$params = array (
		    ':P_CDFILIAL'     => $param['CDFILIALPROC'],
		    ':P_NRLANCTONF'   => $param['NRLANCTONFROYA']
		);
		$result = $this->entityManager->getConnection()->fetchAll(self::adqNotaFiscal, $params);
		return($result);
	}
    
    private function adqParamGeral($param) {
		$result = $this->entityManager->getConnection()->fetchAll(self::adqParamGeral, $param);
		
		return($result);
	}
	
	private function getparavend ($param) {
        $result = [];
	    $conditions = array();
        
        if(isset($param['CDFILIALFRANQUIADA'])) {
	        if(is_array($param['CDFILIALFRANQUIADA'])) {
                $conditions['P_CDFILIFRAN'] = implode('_', $param['CDFILIALFRANQUIADA']);
            } else {
                $conditions['P_CDFILIFRAN'] = $param['CDFILIALFRANQUIADA'];
            }
	        $result = $this->entityManager->getConnection()->fetchAll(self::adqParaVend, $conditions);
        }
        
		return($result);
	}
	
	private function adqProdutoNota ($param) {
		$params = array (
		    ':P_CDFILIAL'   => ($param['CDFILIALPROC'])
		 );
		$produto = $this->entityManager->getConnection()->fetchAll(self::adqProdutoNota, $params);
		return($produto);
	}
	
	private function getfaturamentobruto ($DTFIMPERTAXA,$DTINIPERTAXA,$CDFILIAL){
		$params = array ( 
		    ':P_CDFILIAL'   => $CDFILIAL,
		    ':P_DATAFIM'    => $DTFIMPERTAXA,
		    ':P_DATAINI'    => $DTINIPERTAXA
		);
		$FaturamentoBruto = $this->entityManager->getConnection()->fetchAll(self::adqFatBruto, $params);
		return($FaturamentoBruto);
	}
	
	private function getmovtofrank ($DTFIMPERTAXA,$DTINIPERTAXA,$CDFILIAL){
		$params = array( 
		    ':P_CDFILIFRAN' => $CDFILIAL,
		    ':P_DTFIM'      => $DTFIMPERTAXA,
		    ':P_DTINI'      => $DTINIPERTAXA
		);
		$result = $this->entityManager->getConnection()->fetchAll(self::GetMovToFranq, $params);
		return($result);
	}
	
	public function getInfosByFilial($value) {
        $params = array(
            'NRORG'     => $value['NRORG'],
			'CDFILIAL'  => $value['CDFILIALPROC']
		);

		$infos = $this->entityManager->getConnection()->fetchAll(self::GET_INFO_FILIAL, $params)[0];
		return $infos;
    }
	
	private function NOVO_CODIGO($params){
	    try{
            $this->entityManager->beginTransaction();
            $procedure = new StoredProcedure($this->entityManager->getConnection(),'NOVO_CODIGO');
            $procedure->addParam(new Param('P_CONTADOR', Param::PARAM_INPUT,'LANCNF/FILIAL'.$params['CDFILIALPROC'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_SEQUENCIAL', Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 20));
            $procedure->addParam(new Param('P_QTDE', Param::PARAM_INPUT, 1, Param::PARAM_TYPE_INT));
            $procedure->addParam(new Param('P_NRORG', Param::PARAM_INPUT, $params['NRORG'], Param::PARAM_TYPE_INT));
            $result = $procedure->execute();
            $formatado = substr($result["P_SEQUENCIAL"], -10);
            $this->entityManager->commit();
            return $formatado;
        }catch (\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
	}
	
	private function Gera_NotaFiscal_Corpo($params,$adqProdutoNota,$stNrLanctoNF){
	    $currentDate = new DateTime();
        $currentDateFormatted = $currentDate->format('d/m/Y');
        $dtInicial = DateTime::createFromFormat('d/m/Y', date('d/m/Y'));
        $params = array(
            'P_CDFILIAL'        => $params['CDFILIALPROC'],
            'P_CDFILIEMIT'      => $params['CDFILIALPROC'],
            'P_CDEMPRESA'       => $params["CDEMPRESA"],
            'P_CDTIPOOPER'      => $adqProdutoNota[0]["CDTIPOOPERFRAN"],
            'P_CDSERIE'         => $adqProdutoNota[0]["CDSERIEFRAN"],
            'P_CDCLIENTE'       => $params["CDCLIFRAN"],
            'P_DTENTRSAID'      => $dtInicial->format('d/m/Y'),
            'P_IDSISTEMA'       => 'VND',
            'P_ATUAESTOQUE'     => 'S',
            'P_NRLANCTONF'      => $stNrLanctoNF,
            'P_NRAPURACFAT'     => '',
            'P_IDTPIJURTRAN'    => (array_key_exists("IDTPIJURTRAN", $params)) ? $params["IDTPIJURTRAN"] : null,
            'P_NRINSJURTRAN'    => (array_key_exists("NRINSJURTRAN", $params)) ? $params["NRINSJURTRAN"] : null,
            'P_NRPLACAVEIC'     => (array_key_exists("NRPLACAVEIC", $params)) ? $params["NRPLACAVEIC"] : null,
            'P_SGUFVEIC'        => (array_key_exists("SGUFVEIC", $params)) ? $params["SGUFVEIC"] : null,
            'P_IDPGTOFRETE'     => (array_key_exists("IDPGTOFRETE", $params)) ? $params["IDPGTOFRETE"] : null,
            'P_DSQTDEVOLU'      => (array_key_exists("DSQTDEVOLU", $params)) ? $params["DSQTDEVOLU"] : null,
            'P_DSESPECVOLU'     => (array_key_exists("DSESPECVOLU", $params)) ? $params["DSESPECVOLU"] : null,
            'P_DSMARCAVOLU'     => (array_key_exists("DSMARCAVOLU", $params)) ? $params["DSMARCAVOLU"] : null,
            'P_DSNUMEVOLU'      => (array_key_exists("DSNUMEVOLU", $params)) ? $params["DSNUMEVOLU"] : null,
            'P_VRPBRUTOVOLU'    => 0,
            'P_VRPLIQUVOLU'     => 0,
            'P_NRLANCESTQ'      => (array_key_exists("NRLANCESTQ", $params)) ? $params["NRLANCESTQ"] : null,
            'P_NRLANCORIG'      => (array_key_exists("NRLANCORIG", $params)) ? $params["NRLANCORIG"] : null,
            'P_DTLANCAMENNF'    => $dtInicial->format('d/m/Y'),
            'P_IDGEROUTDOCU'    => null,
            'P_DTCOMPFATUR'     => null,
            'P_CDPTOVNDFATURNF' => null
            
        );
	    try{
            $this->entityManager->beginTransaction();
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'GERA_NOTAFISCAL_CORPO');
            $procedure->addParam(new Param('P_CDFILIAL',        Param::PARAM_INPUT, $params['P_CDFILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFILIEMIT',      Param::PARAM_INPUT, $params['P_CDFILIEMIT'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDEMPRESA',       Param::PARAM_INPUT, $params["P_CDEMPRESA"], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDTIPOOPER',      Param::PARAM_INPUT, $params['P_CDTIPOOPER'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDSERIE',         Param::PARAM_INPUT, $params['P_CDSERIE'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCLIENTE',       Param::PARAM_INPUT, $params['P_CDCLIENTE'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTENTRSAID',      Param::PARAM_INPUT, $params['P_DTENTRSAID'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDSISTEMA',       Param::PARAM_INPUT, $params['P_IDSISTEMA'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_PRXLANCTONF',     Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 10));
            $procedure->addParam(new Param('P_PRXLANCESTQ',     Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 10));
            $procedure->addParam(new Param('P_ATUAESTOQUE',     Param::PARAM_INPUT, $params['P_ATUAESTOQUE'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRAPURACFAT',     Param::PARAM_INPUT, $params['P_NRAPURACFAT'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF',      Param::PARAM_INPUT, $params['P_NRLANCTONF'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDTPIJURTRAN',    Param::PARAM_INPUT, $params['P_IDTPIJURTRAN'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRINSJURTRAN',    Param::PARAM_INPUT, $params['P_NRINSJURTRAN'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRPLACAVEIC',     Param::PARAM_INPUT, $params['P_NRPLACAVEIC'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_SGUFVEIC',        Param::PARAM_INPUT, $params['P_SGUFVEIC'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDPGTOFRETE',     Param::PARAM_INPUT, $params['P_IDPGTOFRETE'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSQTDEVOLU',      Param::PARAM_INPUT, $params['P_DSQTDEVOLU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSESPECVOLU',     Param::PARAM_INPUT, $params['P_DSESPECVOLU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSMARCAVOLU',     Param::PARAM_INPUT, $params['P_DSMARCAVOLU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSNUMEVOLU',      Param::PARAM_INPUT, $params['P_DSNUMEVOLU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_VRPBRUTOVOLU',    Param::PARAM_INPUT, $params['P_VRPBRUTOVOLU'], Param::PARAM_TYPE_INT));
            $procedure->addParam(new Param('P_VRPLIQUVOLU',     Param::PARAM_INPUT, $params['P_VRPLIQUVOLU'], Param::PARAM_TYPE_INT));
            $procedure->addParam(new Param('P_NRLANCESTQ',      Param::PARAM_INPUT, $params['P_NRLANCESTQ'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCORIG',      Param::PARAM_INPUT, $params['P_NRLANCORIG'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTLANCAMENNF',    Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDGEROUTDOCU',    Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTCOMPFATUR',     Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR)); 
            $procedure->addParam(new Param('P_CDPTOVNDFATURNF', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));

            $result=$procedure->execute();
            $this->entityManager->commit();
            return $result;
        }catch (\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
	    
	
	}
	
	private function Gera_NotaFiscal_Produto($params,$NotaFiscal,$adqProdutoNota,$flag){
	    if($flag){
    	    $params = array(
                'P_CDFILIAL' => $params['CDFILIALPROC'],
                'P_NRLANCTONF' => $NotaFiscal['P_PRXLANCTONF'],
                'P_CDPRODUTO' => $adqProdutoNota[0]['CDPRODUTOROY'],
                'P_CDPRODEMIS' => $adqProdutoNota[0]['CDPRODUTOROY'],
                'P_DSPRODEMIS' => $adqProdutoNota[0]['NMPRODUTOROY'],
                'P_QTITEMPROD' => 1,
                'P_VRUNITITEM' => $params['VRBOLEROYALT'],
                'P_VRDESCITEM' => 0,
                'P_CDFILIALITG' => $params['CDFILIALPROC'],
                'P_NRINTEGRACAO' => null,
                'P_NRITEMINTEGR' => null,
                'P_CDCSTINFUSU' => null,
                'P_CDCFOPINFUSU' => null,
                'P_CDSUFXINFUSU' => null,
                'P_CDALMOXARIFE' => null,
                'P_CDLOCALESTOQ' => null,
                'P_NRLOTEESTQ' => null,
                'P_NRSUBLOTE' => null,
                'P_IDCONFORITEM' => 'N',
                'P_IDTPNFCREDEB' => null,
                'P_QTVOLUITEM' => 0,
                'P_CDSERVFILI' => null,
                'P_CDFILIAPUR' => null,
                'P_CDMARCA' => null,
                'P_CDSERVFATU' => null,
                'P_IDORIGEMPROD' => 'N',
                'P_IDATUESTPROD' => 'S',
                'P_VRICMSSTITORIG' => 0,
                'P_DSJUSTIFICATIVA' => null,
                'P_DSINFADICPROD' => null,
                'P_CDFISOPEITEM' => null
            );
	    }else{
	        $params = array(
            'P_CDFILIAL' => $params['CDFILIALPROC'],
            'P_NRLANCTONF' => $NotaFiscal['P_PRXLANCTONF'],
            'P_CDPRODUTO' => $adqProdutoNota[0]['CDPRODUTOMAR'],
            'P_CDPRODEMIS' => $adqProdutoNota[0]['CDPRODUTOMAR'],
            'P_DSPRODEMIS' => $adqProdutoNota[0]['NMPRODUTOMAR'],
            'P_QTITEMPROD' => 1,
            'P_VRUNITITEM' => $params['VRBOLEROYALT'],
            'P_VRDESCITEM' => 0,
            'P_CDFILIALITG' => $params['CDFILIALPROC'],
            'P_NRINTEGRACAO' => null,
            'P_NRITEMINTEGR' => null,
            'P_CDCSTINFUSU' => null,
            'P_CDCFOPINFUSU' => null,
            'P_CDSUFXINFUSU' => null,
            'P_CDALMOXARIFE' => null,
            'P_CDLOCALESTOQ' => null,
            'P_NRLOTEESTQ' => null,
            'P_NRSUBLOTE' => null,
            'P_IDCONFORITEM' => 'N',
            'P_IDTPNFCREDEB' => null,
            'P_QTVOLUITEM' => 0,
            'P_CDSERVFILI' => null,
            'P_CDFILIAPUR' => null,
            'P_CDMARCA' => null,
            'P_CDSERVFATU' => null,
            'P_IDORIGEMPROD' => 'N',
            'P_IDATUESTPROD' => 'S',
            'P_VRICMSSTITORIG' => 0,
            'P_DSJUSTIFICATIVA' => null,
            'P_DSINFADICPROD' => null,
            'P_CDFISOPEITEM' => null
        );
	    }
	    try{
            $this->entityManager->beginTransaction();
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'Gera_NotaFiscal_Produto');
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $params['P_CDFILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT, $params['P_NRLANCTONF'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDPRODUTO', Param::PARAM_INPUT, $params['P_CDPRODUTO'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDPRODEMIS', Param::PARAM_INPUT, $params['P_CDPRODEMIS'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSPRODEMIS', Param::PARAM_INPUT, $params['P_DSPRODEMIS'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_QTITEMPROD', Param::PARAM_INPUT, $params['P_QTITEMPROD'], Param::PARAM_TYPE_INT));
            $procedure->addParam(new Param('P_VRUNITITEM', Param::PARAM_INPUT, $params['P_VRUNITITEM'], Param::PARAM_TYPE_INT));
            $procedure->addParam(new Param('P_VRDESCITEM', Param::PARAM_INPUT, $params['P_VRDESCITEM'], Param::PARAM_TYPE_INT));
            $procedure->addParam(new Param('P_CDFILIALITG', Param::PARAM_INPUT, $params['P_CDFILIALITG'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRINTEGRACAO', Param::PARAM_INPUT, $params['P_NRINTEGRACAO'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRITEMINTEGR', Param::PARAM_INPUT, $params['P_NRITEMINTEGR'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCSTINFUSU', Param::PARAM_INPUT, $params['P_CDCSTINFUSU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCFOPINFUSU', Param::PARAM_INPUT, $params['P_CDCFOPINFUSU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDSUFXINFUSU', Param::PARAM_INPUT, $params['P_CDSUFXINFUSU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDALMOXARIFE', Param::PARAM_INPUT, $params['P_CDALMOXARIFE'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDLOCALESTOQ', Param::PARAM_INPUT, $params['P_CDLOCALESTOQ'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLOTEESTQ', Param::PARAM_INPUT, $params['P_NRLOTEESTQ'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRSUBLOTE', Param::PARAM_INPUT, $params['P_NRSUBLOTE'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDCONFORITEM', Param::PARAM_INPUT, $params['P_IDCONFORITEM'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDTPNFCREDEB', Param::PARAM_INPUT, $params['P_IDTPNFCREDEB'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_QTVOLUITEM', Param::PARAM_INPUT, $params['P_QTVOLUITEM'], Param::PARAM_TYPE_INT));
            $procedure->addParam(new Param('P_CDSERVFILI', Param::PARAM_INPUT, $params['P_CDSERVFILI'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFILIAPUR', Param::PARAM_INPUT, $params['P_CDFILIAPUR'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDMARCA', Param::PARAM_INPUT, $params['P_CDMARCA'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDSERVFATU', Param::PARAM_INPUT, $params['P_CDSERVFATU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDORIGEMPROD', Param::PARAM_INPUT, $params['P_IDORIGEMPROD'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDATUESTPROD', Param::PARAM_INPUT, $params['P_IDATUESTPROD'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_VRICMSSTITORIG', Param::PARAM_INPUT, $params['P_VRICMSSTITORIG'], Param::PARAM_TYPE_INT));
            $procedure->addParam(new Param('P_DSJUSTIFICATIVA', Param::PARAM_INPUT, $params['P_DSJUSTIFICATIVA'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSINFADICPROD', Param::PARAM_INPUT, $params['P_DSINFADICPROD'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFISOPEITEM', Param::PARAM_INPUT, $params['P_CDFISOPEITEM'], Param::PARAM_TYPE_STR));
            $procedure->execute();
            $result=$this->entityManager->commit(); 
            return true;
        }catch (\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
	
	}
    
    private function GERA_NOTAFISCAL_FECHAMENTO($params,$NotaFiscal){
	    $params = array(
            'P_CDFILIAL' => $params['CDFILIALPROC'],
            'P_NRLANCTONF' => $NotaFiscal["P_PRXLANCTONF"],
            'P_DATAPROC' => null,///valor obtido por essa funçao que eu nao tenho acesso DataProc(stFiliMovi);
            'P_NRLANCESTQ' => $NotaFiscal["P_PRXLANCESTQ"],
            'P_EVOLESTOQ' => 'S',
            'P_CDOPERADOR' => null,
            'P_IDBLOQTRANS' => null,
            'P_IDATUESTOQ' => null
        );
    
	    try{
            $this->entityManager->beginTransaction();
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'GERA_NOTAFISCAL_FECHAMENTO');
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $params['P_CDFILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT, $params['P_NRLANCTONF'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DATAPROC', Param::PARAM_INPUT, $params['P_DATAPROC'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCESTQ', Param::PARAM_INPUT, $params['P_NRLANCESTQ'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_EVOLESTOQ', Param::PARAM_INPUT, $params['P_EVOLESTOQ'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $params['P_CDOPERADOR'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDBLOQTRANS', Param::PARAM_INPUT, $params['P_IDBLOQTRANS'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDATUESTOQ', Param::PARAM_INPUT, $params['P_IDATUESTOQ'], Param::PARAM_TYPE_STR));
            $procedure->execute();
            $result=$this->entityManager->commit();
            return true;
        }catch (\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
	
	}
	
	private function GERA_DADOS_FINANCEIRO($params,$NotaFiscal,$stNrLanctoNF){
	    $params = array(
	        'P_CDFILIAL' => $params['CDFILIAL'],
            'P_NRLANCTONF' => $stNrLanctoNF,
            'P_CDFILIPROC' => $params['CDFILIALPROC'],
            'P_IDOPERACAO' => 'L',
            'P_RESULTADO' => ''
        );
	    try{
            $this->entityManager->beginTransaction();
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'GERA_DADOS_FINANCEIRO');
            $procedure->addParam(new Param('P_CDFILIAL',   Param::PARAM_INPUT, $params['P_CDFILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT, $params['P_NRLANCTONF'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFILIPROC', Param::PARAM_INPUT, $params['P_CDFILIPROC'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDOPERACAO', Param::PARAM_INPUT, $params['P_IDOPERACAO'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_RESULTADO',  Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR));
            $procedure->execute();
            $result=$this->entityManager->commit();
            return true;
        }catch (\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
	
	}
	
	private function NF_BAIXA_AF($params,$adqItensNF,$stItemNF,$dbQtitemprod,$adqItemProdAFXML=null,$stCdProduto){
	    if ($dbQtitemprod != 0 && $stItemNF == 'N') {
            $params['NEWCDPRODEMIS'] = $adqItemProdAFXML['CDARVPROD'];
            $params['OLDCDPRODEMIS'] = $adqItemProdAFXML['CDARVPROD'];
        } else {
            $params['NEWCDPRODEMIS'] = $adqItensNF['CDPRODEMIS'];
            $params['OLDCDPRODEMIS'] = $adqItensNF['CDPRODEMIS'];
        }
        
        if ($dbQtitemprod != 0 && $stItemNF == 'N') {
            $params['NEWCDPRODUTO'] = $stCdProduto;
            $params['OLDCDPRODUTO'] = $stCdProduto;
        } else {
            $params['NEWCDPRODUTO'] = $adqItensNF['CDPRODUTO'];
            $params['OLDCDPRODUTO'] = $adqItensNF['CDPRODUTO'];
        }

        
	    $params = array(
            'P_CDFILIAL' => $params['CDFILIALNF'],
            'P_NRLANCTONF' => $params['NRLANCTONFROYA'],
            'P_NRSEQITPROD' => $adqItensNF['NRSEQITPROD'],
            'P_IDSTATUS' => 'E',
            'P_NEWCDPRODEMIS' => $params['NEWCDPRODEMIS'],
            'P_OLDCDPRODEMIS' => $params['OLDCDPRODEMIS'],
            'P_NEWCDPRODUTO' => $params['NEWCDPRODUTO'],
            'P_OLDCDPRODUTO' => $params['OLDCDPRODUTO'],
            'P_NEWCDMARCA' => $adqItensNF['CDMARCA'],
            'P_OLDCDMARCA' => $adqItensNF['CDMARCA'],
            'P_NEWQTITEMPROD' => $adqItensNF['QTITEMPROD'],
            'P_OLDQTITEMPROD' => $adqItensNF['QTITEMPROD']        );

	    try{
            $this->entityManager->beginTransaction();
            $procedure = new StoredProcedure($this->entityManager->getConnection(),'NF_BAIXA_AF');
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $params['P_CDFILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT, $params['P_NRLANCTONF'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRSEQITPROD', Param::PARAM_INPUT, $params['P_NRSEQITPROD'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDSTATUS', Param::PARAM_INPUT, $params['P_IDSTATUS'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NEWCDPRODEMIS', Param::PARAM_INPUT, $params['P_NEWCDPRODEMIS'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_OLDCDPRODEMIS', Param::PARAM_INPUT, $params['P_OLDCDPRODEMIS'], Param::PARAM_TYPE_STR,));
            $procedure->addParam(new Param('P_NEWCDPRODUTO', Param::PARAM_INPUT, $params['P_NEWCDPRODUTO'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_OLDCDPRODUTO', Param::PARAM_INPUT, $params['P_OLDCDPRODUTO'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NEWCDMARCA', Param::PARAM_INPUT, $params['P_NEWCDMARCA'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_OLDCDMARCA', Param::PARAM_INPUT, $params['P_OLDCDMARCA'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NEWQTITEMPROD', Param::PARAM_INPUT, $params['P_NEWQTITEMPROD'], Param::PARAM_TYPE_INT));
            $procedure->addParam(new Param('P_OLDQTITEMPROD', Param::PARAM_INPUT, $params['P_OLDQTITEMPROD'], Param::PARAM_TYPE_INT));
            $procedure->addParam(new Param('P_IDERRO', Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 200));
            $result = $procedure->execute();
            $this->entityManager->commit();
            return $result;
        }catch (\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
	}
    
     private function DELETA_NF($params,$P_IDCORPITEM){
         
	    $params = array(
            'P_FILIAL' => $params['CDFILIALNF'],
            'P_LANCTONF' => $params['NRLANCTONFROYA'],
            'P_IDCORPITEM' => $P_IDCORPITEM
        );

	    try{
            $this->entityManager->beginTransaction();
            $procedure = new StoredProcedure($this->entityManager->getConnection(),'DELETA_NF');
            $procedure->addParam(new Param('P_FILIAL', Param::PARAM_INPUT, $params['P_FILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_LANCTONF', Param::PARAM_INPUT, $params['P_LANCTONF'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDCORPITEM', Param::PARAM_INPUT, $params['P_IDCORPITEM'], Param::PARAM_TYPE_STR));
            $procedure->execute();
            $result=$this->entityManager->commit();
            return true;
        }catch (\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
	
	}
	
	private function acmDelNotaFiscalRoy($params){
         
	    $params = array(
            'NRLANCTONFROYA' => '',
            'CDFILIALFRAN' => $params['CDFILIALFRAN'],
            'IDSITUNOTA' => 'A',
            'DTFECHAFRANQ' => $dateWithoutHours = substr($params['DTFECHAFRANQ'], 0, 10)
        );
	    try{
	      $return =  $this->entityManager->getConnection()->executeQuery(self::acmDelNotaFiscalRoy, $params);
	        return($return);
	    }catch (\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
	
	}
	
	private function acmDelNotaFiscalMar($params){
	    $params = array(
            'NRLANCTONFMARK' => '',
            'CDFILIALFRAN' => $params['CDFILIALFRAN'],
            'IDSITUNOTA' => 'A',
            'DTFECHAFRANQ' => $dateWithoutHours = substr($params['DTFECHAFRANQ'], 0, 10)
        );
	    try{
	      $return =  $this->entityManager->getConnection()->executeQuery(self::acmDelNotaFiscalMar, $params);
	        return($return);
	    }catch (\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
	
	}
    
    private function acmUpdNotaFiscalRoy ($param,$stNrLanctoNF) {
        
		$params = array
		( ':CDFILIALNF' => $param['CDFILIALPROC'],
		  ':NRLANCTONFROYA' =>$stNrLanctoNF,
		  ':CDFILIALFRAN' => $param['CDFILIAL'],
		  ':IDSITUNOTA' => 'G',
		  ':DTFECHAFRANQ' => $param['DTFECHAFRANQ'],
		  ':DTHRGERANF' => $dataAtual = strftime('%d/%m/%Y %H:%M:%S')
		
		);
		 $return = $this->entityManager->getConnection()->executeQuery(self::acmUpdNotaFiscalRoy, $params);
		return($return);
	}
	
	private function acmUpdContaReceber($param,$stNrLanctoNF) {
		$params = array
		( ':CDFILIAL' => $param['CDFILIALPROC'],
		  ':NRLANCTONF' =>$stNrLanctoNF,
		  ':DTORIGVENREC' => $param['DTFECHAFRANQ'],
		  ':DTATUAVENREC' => $param['DTFECHAFRANQ']

		);
		
		$return = $this->entityManager->getConnection()->executeQuery(self::acmUpdContaReceber, $params);
		return($return);
	}
	
	private function acmUpdNotaFiscalMar ($param,$stNrLanctoNF) {
		$params = array
		( ':CDFILIALNF' => $param['CDFILIALPROC'],
		  ':NRLANCTONFMARK' =>$stNrLanctoNF,
		  ':CDFILIALFRAN' => $param['CDFILIAL'],
		  ':IDSITUNOTA' => 'G',
		  ':DTFECHAFRANQ' => $param['DTFECHAFRANQ'],
		  ':DTHRGERANF' => $dataAtual = strftime('%d/%m/%Y %H:%M:%S')

		);
		$return = $this->entityManager->getConnection()->executeQuery(self::acmUpdNotaFiscalMar, $params);
		
		return($return);
	}
	
	private function adqFilial($param) {
		$params = array
		( ':P_CDFILIAL' => ($param['CDFILIALPROC'])
		);
		$seqcode = $this->entityManager->getConnection()->fetchAll(self::adqFilial, $params);
		return($seqcode);
	}
	
    public function findFranqueadora(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "Filial_Franqueadora";
        $this->parameterBagColumns = $parameterBagColumns = array('NRORG', "CDOPERADOR");
        parent::find($request, $response);
    }
    
    public function findFranquia(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "Filial_Franquia";
        $this->parameterBagColumns = $parameterBagColumns = array('NRORG', "CDOPERADOR");
        parent::find($request, $response);
    }
    
    public function saveRoyalt(Row $params, DTO\Response $response) {
        $conditions = $params->getRow();
        
        $params = array(
            ':CDFILIALFRAN' =>  $conditions['CDFILIALFRAN'],
            ':VRFATBRUTO'   =>  $conditions['VRFATBRUTO'],
            ':DTFECHAFRANQ' =>  $conditions['DTFECHAFRANQ']
        );
        
        try{
            $this->entityManager->getConnection()->executeQuery(self::updateVrBruto, $params);
        } catch (\Exception $e) {
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
	const updateVrBruto = "
       UPDATE
           MOVTOFRANQUIA
        SET
            VRFATBRUTO = :VRFATBRUTO
        WHERE
           (CDFILIALFRAN = :CDFILIALFRAN) AND
           (DTFECHAFRANQ = :DTFECHAFRANQ)";
    
	const GET_INFO_FILIAL = "
		SELECT
		    CDEMPRESA, CDINSCESTA
		FROM
		    FILIAL
		WHERE 
		    CDFILIAL  = :CDFILIAL
		    AND NRORG = :NRORG
	";
	
	const adqFilial = "
       SELECT
           CDEMPRESA
        FROM
           FILIAL
        WHERE
           CDFILIAL = :P_CDFILIAL";
	
	const acmUpdNotaFiscalMar = "
       UPDATE
           MOVTOFRANQUIA
        SET
           CDFILIALNF     = :CDFILIALNF,
           DTHRGERANF     = :DTHRGERANF,
           IDSITUNOTA     = :IDSITUNOTA,
           NRLANCTONFMARK = :NRLANCTONFMARK
        WHERE
           (CDFILIALFRAN = :CDFILIALFRAN) AND
           (DTFECHAFRANQ = :DTFECHAFRANQ)";
	
	const acmUpdContaReceber = "
       UPDATE
           CONTARECEBER
        SET
           DTORIGVENREC = :DTORIGVENREC,
           DTATUAVENREC = :DTATUAVENREC
        WHERE
           (CDFILIAL   = :CDFILIAL  ) AND
           (NRLANCTONF = :NRLANCTONF)";
	
	const acmUpdNotaFiscalRoy = "
       UPDATE
           MOVTOFRANQUIA
        SET
           CDFILIALNF     = :CDFILIALNF,
           DTHRGERANF     = :DTHRGERANF,
           IDSITUNOTA     = :IDSITUNOTA,
           NRLANCTONFROYA = :NRLANCTONFROYA
        WHERE
           (CDFILIALFRAN = :CDFILIALFRAN) AND
           (DTFECHAFRANQ = :DTFECHAFRANQ)";
	    
	const adqParaVend = "
        SELECT
           'N' AS IDCHECK, 'P' AS IDSITUNOTA, P.CDFILIAL, F.NMFILIAL, P.IDTPTAXAROYA,
           P.IDTPTAXAMARK, P.DTFECHAFRANQ, NVL(P.VRPERCROYALT,0) AS VRPERCROYALT, NVL(P.VRFIXOROYALT,0) AS VRFIXOROYALT,
           NVL(P.VRPERCMARKET,0) AS VRPERCMARKET, NVL(P.VRFIXOMARKET,0) AS VRFIXOMARKET, P.TPVENCNF, P.DIAVENCNF, P.CDCLIFRAN, P.NMRAZSOCCLIEFRAN
        FROM
           PARAVEND P, FILIAL F
        WHERE
            P.IDTPTAXAROYA not in (1)AND
            P.IDTPTAXAMARK not in (1)AND
           (P.CDFILIAL = F.CDFILIAL  ) AND
           ((INSTR(:P_CDFILIFRAN, P.CDFILIAL) <> 0) OR (:P_CDFILIFRAN = 'T'))
        ORDER BY
       P.CDFILIAL";
   
   const adqProdutoNota = "
    SELECT
       CDPRODUTOROY, NMPRODUTOROY, CDPRODUTOMAR, NMPRODUTOMAR,
       CDSERIEFRAN, DSSERIEFRAN, CDTIPOOPERFRAN, NMTIPOOPERFRAN
    FROM
       PARAVEND
    WHERE
       CDFILIAL = :P_CDFILIAL
       ";
       
   const adqFatBruto = "
    SELECT
       SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS TOTAL
    FROM
       VENDA VE, ITEMVENDA IT, LOJA LO
    WHERE
       (IT.CDPRODUTO  <> NVL(LO.CDPRODTAXASERV,'X')) AND
       (IT.CDPRODUTO  <> NVL(LO.CDPRODTAXAENTR,'X')) AND
       (VE.CDFILIAL    = LO.CDFILIAL  ) AND
       (VE.CDLOJA      = LO.CDLOJA    ) AND
       (VE.CDFILIAL    = :P_CDFILIAL  ) AND
       (VE.CDFILIAL    = IT.CDFILIAL  ) AND
       (VE.CDCAIXA     = IT.CDCAIXA   ) AND
       (VE.NRSEQVENDA  = IT.NRSEQVENDA) AND
       (VE.IDSITUVENDA = 'O'          ) AND
       (VE.DTENTRVENDA BETWEEN :P_DATAINI AND :P_DATAFIM)
       ";
       
    
    const cdsMovToFranqInsert = "
    INSERT INTO MOVTOFRANQUIA
       (CDFILIALFRAN, NMFILIALFRAN, DTFECHAFRANQ, IDTPTAXAROYA, IDTPTAXAMARK, IDSITUNOTA,
        CDCLIFRAN, NMRAZSOCCLIEFRAN , DTINIPERTAXA, DTFIMPERTAXA, VRFATBRUTO, VRPERCROYALT,
        VRFIXOROYALT, VRBOLEROYALT, VRPERCMARKET, VRFIXOMARKET, VRNOTAMARKET, DTVENCTONF, DTHRAPURTAXA, IDVIAIMPORTACAO)
    VALUES
       (:CDFILIALFRAN, :NMFILIALFRAN, :DTFECHAFRANQ, :IDTPTAXAROYA, :IDTPTAXAMARK, :IDSITUNOTA,
        :CDCLIFRAN, :NMRAZSOCCLIEFRAN , :DTINIPERTAXA, :DTFIMPERTAXA, :VRFATBRUTO, :VRPERCROYALT,
        :VRFIXOROYALT, :VRBOLEROYALT, :VRPERCMARKET, :VRFIXOMARKET, :VRNOTAMARKET, :DTVENCTONF, :DTHRAPURTAXA, :IDVIAIMPORTACAO)
    ";
       
       
    const cdsMovToFranqEdit = "
        UPDATE
           MOVTOFRANQUIA
        SET
           NMFILIALFRAN = :NMFILIALFRAN,
           IDTPTAXAROYA = :IDTPTAXAROYA,
           IDTPTAXAMARK = :IDTPTAXAMARK,
           IDSITUNOTA   = :IDSITUNOTA,
           DTINIPERTAXA = :DTINIPERTAXA,
           DTFIMPERTAXA = :DTFIMPERTAXA,
           VRFATBRUTO   = :VRFATBRUTO,
           VRPERCROYALT = :VRPERCROYALT,
           VRFIXOROYALT = :VRFIXOROYALT,
           VRBOLEROYALT = :VRBOLEROYALT,
           VRPERCMARKET = :VRPERCMARKET,
           VRFIXOMARKET = :VRFIXOMARKET,
           VRNOTAMARKET = :VRNOTAMARKET,
           DTVENCTONF   = :DTVENCTONF,
           DTHRAPURTAXA = :DTHRAPURTAXA,
           DTHRGERANF   = :DTHRGERANF,
           IDVIAIMPORTACAO = :IDVIAIMPORTACAO
        WHERE
           (CDFILIALFRAN = :CDFILIALFRAN) AND
           (DTFECHAFRANQ = :DTFECHAFRANQ)
       ";   
    
    const GetMovToFranq = "
    SELECT
       *
    FROM
       MOVTOFRANQUIA
    WHERE
       (DTFECHAFRANQ BETWEEN :P_DTINI AND :P_DTFIM) AND
       ((INSTR(:P_CDFILIFRAN, CDFILIALFRAN) <> 0) OR (:P_CDFILIFRAN = 'T'))
    ";
    
    const adqNotaFiscal = "
        SELECT CDFILIRECE, CDTIPOOPER, CDFILIEMIT, DTEMISSAO,
       DTENTRSAID, NVL(IDORIGDESTNF,'F') AS IDORIGDESTNF,
       NVL(IDNFGERADAVIAXML, 'N') AS IDNFGERADAVIAXML
  FROM NOTAFISCAL
 WHERE CDFILIAL   = :P_CDFILIAL
   AND NRLANCTONF = :P_NRLANCTONF
   ";
   
   const adqParamGeral = "
        SELECT IDAVNFNOCORR,
           NVL(IDUTDTPROCTNFE, 'N') IDUTDTPROCTNFE,
           DIAINIHORVER,
           MESINIHORVER,
           DIAFIMHORVER,
           MESFIMHORVER,
           NVL(IDUTCTRLFISENTR, 'N') IDUTCTRLFISENTR,
           NVL(IDUTCTRLFISSAID, 'N') IDUTCTRLFISSAID,
           IDUTDTBCDTEMISS,
           IDDTEMISDIFDTBC,
           SYSDATE,
           NVL(IDUTCLOUD, 'N') IDUTCLOUD,
           NVL(IDPERMRELPRAFNF, 'N') IDPERMRELPRAFNF
      FROM PARAMGERAL
     WHERE CDPARGERAL = '0001'
   ";
   
   const adqItensNF = "
        SELECT NRSEQITPROD, CDPRODEMIS, CDPRODUTO, CDMARCA, QTITEMPROD
  FROM ITEMPRODUTO
 WHERE CDFILIAL = :P_CDFILIAL
   AND NRLANCTONF = :P_NRLANCTONF
   ";
   
    const adqItemProdAF = "
        SELECT I.CDPRODUTO, VRFATCONTRIBXML,
              (IP.QTITEMPROD * (NVL(IP.VRFATCONTRIBXML, 1))/(NVL(P.VRFATOCONV,1))) AS QTITEMPROD     
          FROM ITEMAUTF I, NFRELACAF NF, ITEMPRODUTO IP, PRODUTO P
         WHERE NF.CDFILIAL    = :P_CDFILIAL
           AND NF.NRLANCTONF  = :P_NRLANCTONF
           AND IP.CDPRODUTO   = :P_CDPRODUTO
           AND NF.CDFILDEST   = I.CDFILDEST
           AND NF.CDFILLANC   = I.CDFILLANC
           AND NF.NRAUTOFORN  = I.NRAUTOFORN
           AND NF.CDMARCA     = I.CDMARCA
           AND NF.CDPRODUTO   = I.CDPRODUTO
           AND NF.DTPROGENTAF = I.DTPROGENTAF
           AND NF.CDFILIAL    = IP.CDFILIAL
           AND NF.NRLANCTONF  = IP.NRLANCTONF
           AND IP.CDPRODUTO   = I.CDPRODUTO
           AND I.CDPRODUTO    = P.CDPRODUTO
           AND IP.CDPRODUTO   = P.CDPRODUTO
   ";
   
   const adqItemProdAFXML = "
        SELECT I.CDPRODUTO AS CDPRODUTOAF, P1.CDPRODESTO AS CDPRODESTOAF, P1.VRFATOCONV AS VRFATOCONVAF,
               P.CDPRODUTO AS CDPRODUTONF, P.CDPRODESTO CDPRODESTONF, NVL(IP.VRFATCONTRIBXML, P.VRFATOCONV) AS VRFATOCONVNF,
               P1.CDARVPROD
          FROM ITEMAUTF I, NFRELACAF NF, ITEMPRODUTO IP, PRODUTO P, PRODUTO P1
         WHERE NF.CDFILIAL    = :P_CDFILIAL
           AND NF.NRLANCTONF  = :P_NRLANCTONF
           AND IP.CDPRODUTO   = :P_CDPRODUTO
           AND NF.CDFILDEST   = I.CDFILDEST
           AND NF.CDFILLANC   = I.CDFILLANC
           AND NF.NRAUTOFORN  = I.NRAUTOFORN
           AND NF.CDMARCA     = I.CDMARCA
           AND NF.CDPRODUTO   = I.CDPRODUTO
           AND NF.DTPROGENTAF = I.DTPROGENTAF
           AND NF.CDFILIAL    = IP.CDFILIAL
           AND NF.NRLANCTONF  = IP.NRLANCTONF
           AND IP.CDPRODUTO   = P.CDPRODUTO
           AND I.CDPRODUTO    = P1.CDPRODUTO
           AND P.CDPRODESTO   = P1.CDPRODESTO
   ";
   
   const acmDelNotaFiscalRoy = "
		UPDATE
           MOVTOFRANQUIA
        SET
           IDSITUNOTA     = :IDSITUNOTA,
           NRLANCTONFROYA = :NRLANCTONFROYA
        WHERE
           (CDFILIALFRAN = :CDFILIALFRAN) AND
           (DTFECHAFRANQ = :DTFECHAFRANQ)
	";
	
	const acmDelNotaFiscalMar = "
		UPDATE
           MOVTOFRANQUIA
        SET
           IDSITUNOTA     = :IDSITUNOTA,
           NRLANCTONFMARK = :NRLANCTONFMARK
        WHERE
           (CDFILIALFRAN = :CDFILIALFRAN) AND
           (DTFECHAFRANQ = :DTFECHAFRANQ)
	";
	
	const filial_Franqueadora = "
		SELECT
            F.*,
            FO.CDOPERADOR,
            F.CDFILIAL
            || ' -- '
            || F.NMFILIAL AS LABELFILIAL,
            PA.CDPAIS,
            PA.NMPAIS,
            RE.NMREGIAO,
            ES.SGESTADO,
            ES.NMESTADO,
            MU.CDMUNICIPIO,
            MU.NMMUNICIPIO
        FROM
                 FILIAL F
            JOIN FILIOPER  FO ON F.CDFILIAL = FO.CDFILIAL
            JOIN ENDEFILI  EM ON F.CDFILIAL = EM.CDFILIAL
                                AND F.NRORG = EM.NRORG
            LEFT JOIN PAIS      PA ON EM.CDPAIS = PA.CDPAIS
                                 AND EM.NRORG = PA.NRORG
            LEFT JOIN ESTADO    ES ON EM.CDPAIS = ES.CDPAIS
                                   AND EM.SGESTADO = ES.SGESTADO
                                   AND EM.NRORG = ES.NRORG
            LEFT JOIN MUNICIPIO MU ON EM.CDPAIS = MU.CDPAIS
                                      AND EM.SGESTADO = MU.SGESTADO
                                      AND EM.CDMUNICIPIO = MU.CDMUNICIPIO
                                      AND EM.NRORG = MU.NRORG
            LEFT JOIN REGIAO    RE ON F.CDREGIAO = RE.CDREGIAO
                                   AND EM.CDPAIS = RE.CDPAIS
                                   AND EM.SGESTADO = RE.SGESTADO
                                   AND EM.NRORG = RE.NRORG
        WHERE
                FO.CDOPERADOR = :CDOPERADOR
            AND F.IDFUNCAOFILI = :IDFUNCAOFILI
            AND F.NRORG = :NRORG
            AND EM.IDTPENDEFILI = 'P'
            AND F.IDSTATUSBLOQ = 'N'
            AND ( FO.DTVALIDADE IS NULL
                  OR ( TRUNC(FO.DTVALIDADE) >= TRUNC(SYSDATE) ) )
        ORDER BY
            FO.CDFILIAL ASC,
            F.NMFILIAL ASC
	";
	const filial_Franquia = "
		SELECT
            F.*,
            FO.CDOPERADOR,
            F.IDFUNCAOFILI,
            F.CDFILIAL
            || ' -- '
            || F.NMFILIAL AS LABELFILIAL,
            PA.CDPAIS,
            PA.NMPAIS,
            RE.NMREGIAO,
            ES.SGESTADO,
            ES.NMESTADO,
            MU.CDMUNICIPIO,
            MU.NMMUNICIPIO
        FROM
                 FILIAL F
            JOIN FILIOPER  FO ON F.CDFILIAL = FO.CDFILIAL
            JOIN ENDEFILI  EM ON F.CDFILIAL = EM.CDFILIAL
                                AND F.NRORG = EM.NRORG
            LEFT JOIN PAIS      PA ON EM.CDPAIS = PA.CDPAIS
                                 AND EM.NRORG = PA.NRORG
            LEFT JOIN ESTADO    ES ON EM.CDPAIS = ES.CDPAIS
                                   AND EM.SGESTADO = ES.SGESTADO
                                   AND EM.NRORG = ES.NRORG
            LEFT JOIN MUNICIPIO MU ON EM.CDPAIS = MU.CDPAIS
                                      AND EM.SGESTADO = MU.SGESTADO
                                      AND EM.CDMUNICIPIO = MU.CDMUNICIPIO
                                      AND EM.NRORG = MU.NRORG
            LEFT JOIN REGIAO    RE ON F.CDREGIAO = RE.CDREGIAO
                                   AND EM.CDPAIS = RE.CDPAIS
                                   AND EM.SGESTADO = RE.SGESTADO
                                   AND EM.NRORG = RE.NRORG
        WHERE
                FO.CDOPERADOR = :CDOPERADOR
            AND F.IDFUNCAOFILI IS NULL
            AND F.NRORG = :NRORG
            AND EM.IDTPENDEFILI = 'P'
            AND F.IDSTATUSBLOQ = 'N'
            AND ( FO.DTVALIDADE IS NULL
                  OR ( TRUNC(FO.DTVALIDADE) >= TRUNC(SYSDATE) ) )
        ORDER BY
            FO.CDFILIAL ASC,
            F.NMFILIAL ASC
	";
}
