<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Services;
use \Zeedhi\Framework\Util\Functions;

class SelectClienteFilial extends \Teknisa\MAN\Controllers\TeknisaCrud {

	protected $dataSourceName = 'select_clienfilial';
	protected $parameterBagColumns;

    public function __construct ($crudService, $parameterBag, $entityManager) {
        $this->crudService = $crudService;
		$this->parameterBag = $parameterBag;
		$this->entityManager = $entityManager;
    }
    
    public function findClienByFilial(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'select_cliente_by_filial' ;
        $this->find($request,$response);
    }
    
    public function findClientesFiliaisRelatorios(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'select_clienfilial_relatorio';
        
        $conditions = $request->getFilterCriteria()->getConditions();
        $this->parameterBagColumns = ['NRORG', 'CDFILIAL', 'TCDFILIAL'];
        
        $dataSourceFilter = $this->buildParams($conditions);
        
        $filterCriteria = new FilterCriteria(
            $this->dataSourceName,
            $dataSourceFilter,
            $request->getFilterCriteria()->getPage(),
            $request->getFilterCriteria()->getPageSize()
        );
        
        $newRequest = new DTO\Request\Filter(
            $filterCriteria,
            $request->getMethod(),
            $request->getRoutePath(),
            $request->getUserId()
        );
        
        parent::find($newRequest, $response);
    }
    
    private function buildParams($conditions) {
        $params = [];
        
        if(($conditions[0]['columnName'] == "CDFILIAL") && !empty($conditions[0]['value'])) {
            if(is_array($conditions[0]['value'])) {
                $params['CDFILIAL'] = implode("_", $conditions[0]['value']);
            } else {
                $params['CDFILIAL'] = $conditions[0]['value'];
            }
            
            $params['TCDFILIAL'] = "";
        } else {
            $params['CDFILIAL'] = "";
            $params['TCDFILIAL'] = "T";
        }
        
        if(($conditions[1]['columnName'] == "NRORG") && !empty($conditions[1]['value'])) {
            $params['NRORG'] = $conditions[1]['value'];
        }
        
        foreach($params as $key => $value) {
            $dataSourceFilter[] = array(
                "columnName" => $key,
                "operator"   => "=",
                "value"      => $value
            );
        }
        
        return $dataSourceFilter;
    }
}