<?php
namespace Teknisa\MAN\Factories\Management\Repositories;

class Operador extends \Doctrine\ORM\EntityRepository
{
    public static function verificaGrupoAlteraPonto($cdoperador){
        $sql = "SELECT COUNT(*) AS GRUPODPAP
                   FROM OPERADOR OP, OPERGRUPOP OG, AUTGRUPOP AG
                  WHERE OP.CDOPERADOR   = :P_CDOPERADOR
                    AND OP.CDOPERADOR   = OG.CDOPERADOR
                    AND OG.CDGRUPOPER   = AG.CDGRUPOPER
                    AND AG.IDAUTGRUPOP  = 'DPAP'";

        $param = array(
            'P_CDOPERADOR' => $cdoperador
        );

        $entityManager = \Setforms2\Shared\Registry::getEntityManager();
        $result = $entityManager->getConnection()->fetchAll($sql, $param);
        return count($result)>0 ? $result : array();
    }

    public function getEmailOperador($operador)
    {
        $sql = "SELECT DSEMAILOPER
                  FROM OPERADOR
                 WHERE CDOPERADOR = :P_CDOPERADOR";

        $params = array("P_CDOPERADOR" => $operador);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function getEmailGerenteOpe($operador)
    {
        $sql = "SELECT R.DSEMAILOPER
                  FROM FUNCIONARIO F, OPERADOR O, EQUIPETRAB E, OPERADOR R
                 WHERE O.CDOPERADOR = :CDOPERADOR
                   AND O.CDFUNC = F.CDFUNC
                   AND E.CDEQUIPETRAB = F.CDEQUIPETRAB
                   AND R.CDOPERADOR = E.CDOPERRESP";

        $params = array("CDOPERADOR" => $operador);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function maxCdoperador()
    {
        $sqlMax = "SELECT MAX(TO_NUMBER(CDOPERADOR))+1 FROM OPERADOR";
        $result = $this->getEntityManager()->getConnection()->fetchColumn($sqlMax);
        return ($result) ? $result : false;
    }


}