<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelExtratoConsumidorService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function findSintetico($CDFILIAL, $CDTIPOCONS, $DTLANCINI, $DTLANCFIN, $CDLOJA, $CDCONSUMIDOR, $TCDCLIENTE, $TCDLOJA, $TCDCONSUMIDOR, $TCDTIPOCONS, $CDCLIENTE, $TIPOSALDO) {
        $params = array(
            ':CDFILIAL'         => $CDFILIAL,
         	':CDTIPOCONS'       => $CDTIPOCONS,
         	':DTLANCINI'        => $DTLANCINI,
         	':DTLANCFIN'        => $DTLANCFIN,
         	':CDLOJA'           => $CDLOJA,
         	':CDCONSUMIDOR'     => $CDCONSUMIDOR,
         	':TCDCLIENTE'       => $TCDCLIENTE,
         	':TCDCONSUMIDOR'    => $TCDCONSUMIDOR,
         	':TCDLOJA'          => $TCDLOJA,
         	':TCDTIPOCONS'      => $TCDTIPOCONS,
         	':CDCLIENTE'        => $CDCLIENTE
 		);
        $result = $this->entityManager->getConnection()->fetchAll(self::GET_EXTRATO_SINTETICO, $params);
        
 		if ($TIPOSALDO == 'C'){
 		    foreach($result as $chTR => $valTR){
                $dados = array(
                    ':MINDTMOVCLI'         => $result [$chTR]['MINDTMOVCLI'],
                 	':CDCLIENTE'        => $result [$chTR]['CDCLIENTE'],
                 	':CDCONSUMIDOR'     => $result [$chTR]['CDCONSUMIDOR']
         		);
         		$VRSALDPECONS = $this->entityManager->getConnection()->fetchAll(self::GET_VRSALDPECONS, $dados);
         		
     		    $result [$chTR]['ROWCONS'] = $result [$chTR]['CDCONSUMIDOR']." - ".$result [$chTR]['NMCONSUMIDOR'];
     		    $result [$chTR]['CUSTO'] = $result [$chTR]['CDCCUSCLIE']." - ".$result [$chTR]['NMCCUSCLIE'];
     		    $result [$chTR]['SALDOINICONS'] = $VRSALDPECONS[0]['VRSALDPECONS'];
     		    $result [$chTR]['CREDCONS'] = $result [$chTR]['VRCREDITOSPES'];
     		    $result [$chTR]['VRCONS'] = $result [$chTR]['VRMOVPESCONSUMO'];
     		    $result [$chTR]['AJUDEBCONS'] = $result [$chTR]['VRAJUSTEDEBPES'];
     		    $result [$chTR]['SALDOCONS'] = $result [$chTR]['VRSALDPECONS'];
        	}
 		} else {
 		    foreach($result as $chTR => $valTR){
 		        $dados = array(
                    ':MINDTMOVCLI'         => $result [$chTR]['MINDTMOVCLI'],
                 	':CDCLIENTE'        => $result [$chTR]['CDCLIENTE'],
                 	':CDCONSUMIDOR'     => $result [$chTR]['CDCONSUMIDOR']
         		);
         		$VRSALDOCONS = $this->entityManager->getConnection()->fetchAll(self::GET_VRSALDOCONS, $dados);
         		
     		    $result [$chTR]['ROWCONS'] = $result [$chTR]['CDCONSUMIDOR']." - ".$result [$chTR]['NMCONSUMIDOR'];
     		    $result [$chTR]['CUSTO'] = $result [$chTR]['CDCCUSCLIE']." - ".$result [$chTR]['NMCCUSCLIE'];
     		    $result [$chTR]['SALDOINICONS'] = $VRSALDOCONS[0]['VRSALDOCONS'];
     		    $result [$chTR]['CREDCONS'] = $result [$chTR]['VRCREDITOS'];
     		    $result [$chTR]['VRCONS'] = $result [$chTR]['VRMOVCLICONSUMO'];
     		    $result [$chTR]['AJUDEBCONS'] = $result [$chTR]['VRAJUSTEDEBITOS'];
     		    $result [$chTR]['SALDOCONS'] = $result [$chTR]['VRSALDOCONS'];
        	}
 		}
 		
 		return $result;
    }
    
    public function findAnalitico($CDFILIAL, $CDTIPOCONS, $DTLANCINI, $DTLANCFIN, $CDLOJA, $CDCONSUMIDOR, $TCDCLIENTE, $TCDLOJA, $TCDCONSUMIDOR, $TCDTIPOCONS, $CDCLIENTE, $TIPOSALDO) {
        $params = array(
            ':CDFILIAL'         => $CDFILIAL,
         	':CDTIPOCONS'       => $CDTIPOCONS,
         	':DTLANCINI'        => $DTLANCINI,
         	':DTLANCFIN'        => $DTLANCFIN,
         	':CDLOJA'           => $CDLOJA,
         	':CDCONSUMIDOR'     => $CDCONSUMIDOR,
         	':TCDCLIENTE'       => $TCDCLIENTE,
         	':TCDCONSUMIDOR'    => $TCDCONSUMIDOR,
         	':TCDLOJA'          => $TCDLOJA,
         	':TCDTIPOCONS'      => $TCDTIPOCONS,
         	':CDCLIENTE'        => $CDCLIENTE
 		);
 		
 		$result = $this->entityManager->getConnection()->fetchAll(self::GET_EXTRATO_ANALITICO, $params);
 		
 		if ($TIPOSALDO == 'C'){
 		    foreach($result as $chTR => $valTR){
     		    $result [$chTR]['GROUPCONS'] = $result [$chTR]['CDCONSUMIDOR']." - ".$result [$chTR]['NMCONSUMIDOR']." | Saldo Inicial: ".$result [$chTR]['VRSALDOINIPESCONS']." | Saldo Final: ".$result [$chTR]['VRSALDPECONS'];
     		    $result [$chTR]['CUSTO'] = $result [$chTR]['CDCCUSCLIE']." - ".$result [$chTR]['NMCCUSCLIE'];
     		    $result [$chTR]['VRCONS'] = $result [$chTR]['VRMOVPESCONSUMO'];
     		    $result [$chTR]['VRCREDAJUS'] = $result [$chTR]['VRMOVPESOUTR'];
     		    $result [$chTR]['VRSALDEMP'] = $result [$chTR]['VRSALDPECONS'];
        	}
 		} else {
 		    foreach($result as $chTR => $valTR){
     		    $result [$chTR]['GROUPCONS'] = $result [$chTR]['CDCONSUMIDOR']." - ".$result [$chTR]['NMCONSUMIDOR']." | Saldo Inicial: ".$result [$chTR]['VRSALDOINIEMP']." | Saldo Final: ".$result [$chTR]['VRSALDOCONS'];
     		    $result [$chTR]['CUSTO'] = $result [$chTR]['CDCCUSCLIE']." - ".$result [$chTR]['NMCCUSCLIE'];
     		    $result [$chTR]['VRCONS'] = $result [$chTR]['VRMOVCLICONSUMO'];
     		    $result [$chTR]['VRCREDAJUS'] = $result [$chTR]['VRMOVCLIOUTR'];
     		    $result [$chTR]['VRSALDEMP'] = $result [$chTR]['VRSALDOCONS'];
        	}
 		}
 		
 		return $result;
    }
    
    const GET_EXTRATO_SINTETICO = "
    SELECT DISTINCT A.CDCLIENTE   , A.NRINSJURCLIE,   A.IDTPIJURCLIE, A.NMFANTCLIE, A.NMCCUSCLIE,
       A.CDCONSUMIDOR, A.NMCONSUMIDOR,   A.CDTIPOCONS  , A.CDCCUSCLIE, A.VRPESUBCONS,
       A.MAXDTMOVCLI , A.VRMOVCLICONSUMO,A.VRMOVCLIOUTR, A.VRCREDITOS, A.VRAJUSTEDEBITOS,A.VRMOVPESCONSUMO,
       A.VRMOVPESOUTR, A.VRCREDITOSPES,A.VRAJUSTEDEBPES,
       M.VRSALDOCONS , M.VRSALDPECONS, A.MINDTMOVCLI
    FROM
       MOVICLIE M,
       (SELECT DISTINCT M.CDCLIENTE, CL.NRINSJURCLIE, CL.IDTPIJURCLIE, CL.NMFANTCLIE,U.NMCCUSCLIE,
               M.CDCONSUMIDOR, C.NMCONSUMIDOR, C.CDTIPOCONS, C.CDCCUSCLIE, C.VRPESUBCONS,
               MAX(M.DTMOVCLI) AS MAXDTMOVCLI, MIN(M.DTMOVCLI) AS MINDTMOVCLI,
               TRUNC(SUM(NVL((DECODE(M.NRSEQVENDA,NULL,0,DECODE(M.IDTIPMOCVLI,'D',(-1)*M.VRMOVCLI))), 0)), 2) AS VRMOVCLICONSUMO,
               TRUNC(SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVCLI,DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVCLI,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVCLI,0)))), 2) AS VRMOVCLIOUTR,
               TRUNC(SUM(NVL(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVCLI,0), 0)), 2) AS VRCREDITOS,
               TRUNC(SUM(DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVCLI,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVCLI,0))), 2) AS VRAJUSTEDEBITOS,
               TRUNC(SUM(NVL((DECODE(M.NRSEQVENDA,NULL,0,DECODE(M.IDTIPMOCVLI,'D',(-1)*M.VRMOVCLI))), 0)), 2) AS VRMOVPESCONSUMO,
               TRUNC(SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVPESCONS,DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVPESCONS,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVPESCONS,0)))), 2) AS VRMOVPESOUTR,
               TRUNC(SUM(NVL((DECODE(M.IDTIPMOCVLI,'C',M.VRMOVPESCONS)), 0)), 2) AS VRCREDITOSPES,
               TRUNC(SUM(DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVPESCONS,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVPESCONS,0))), 2) AS VRAJUSTEDEBPES
        FROM MOVICLIE M, CLIENTE CL, 
              
              (SELECT CDCLIENTE, CDCONSUMIDOR, CDCCUSCLIE, CDTIPOCONS, NMCONSUMIDOR, VRPESUBCONS FROM CONSUMIDOR
               WHERE
                ((INSTR(:CDTIPOCONS  ,CDTIPOCONS)                 <> 0) OR (:TCDTIPOCONS   = 'T'))) C,
    
              (SELECT CDCLIENTE, CDCCUSCLIE, NMCCUSCLIE FROM CCUSCLIE ) U,
    
              (SELECT CDFILIAL, CDLOJA FROM LOJA
               WHERE
                ((INSTR(:CDLOJA, CDFILIAL||CDLOJA) <> 0) OR (:TCDLOJA = 'T'))) LJ
    
    
        WHERE (M.CDCLIENTE    = CL.CDCLIENTE  ) AND
              (M.CDFILIAL   = LJ.CDFILIAL (+) ) AND
              (C.CDCLIENTE    = M.CDCLIENTE   ) AND
              (C.CDCONSUMIDOR = M.CDCONSUMIDOR) AND
              (M.DTMOVIMCLIE BETWEEN :DTLANCINI AND :DTLANCFIN) AND
              ((INSTR(:CDCLIENTE   ,M.CDCLIENTE) > 0) OR (:TCDCLIENTE = 'T')) AND
              ((INSTR(:CDCONSUMIDOR,M.CDCLIENTE||M.CDCONSUMIDOR)  <> 0) OR (:TCDCONSUMIDOR = 'T')) AND
              (C.CDCLIENTE   = U.CDCLIENTE ) AND
              (C.CDCCUSCLIE  = U.CDCCUSCLIE)          
    
        GROUP BY M.CDCLIENTE, CL.NRINSJURCLIE, CL.IDTPIJURCLIE, CL.NMFANTCLIE,U.NMCCUSCLIE,U.CDCCUSCLIE,
                 M.CDCONSUMIDOR, C.NMCONSUMIDOR, C.CDTIPOCONS, C.CDCCUSCLIE,C.VRPESUBCONS) A
    WHERE M.CDCLIENTE    = A.CDCLIENTE
      AND M.CDCONSUMIDOR = A.CDCONSUMIDOR
      AND M.DTMOVCLI     = A.MAXDTMOVCLI
    ORDER BY
       A.CDCLIENTE,A.CDCCUSCLIE,A.CDCONSUMIDOR
    ";

    const GET_EXTRATO_ANALITICO = "
    SELECT A.*, M.VRSALDOCONS, M.VRSALDPECONS,
       CDCCUSCLIE, ABS (NVL((VRMOVCLICONSUMO*(1-((NVL(VRPESUBCONS, 0))/100))), 0)) AS VRDESCFOL,
       M.VRSALDPECONS - VRMOVPESCONSUMO AS VRSALDOINIPESCONS, M.VRSALDOCONS - VRMOVCLICONSUMO AS VRSALDOINIEMP
    FROM
       MOVICLIE M,
       (SELECT M.CDCLIENTE, CL.NRINSJURCLIE, CL.IDTPIJURCLIE, CL.NMFANTCLIE,C.CDCCUSCLIE, D.NMCCUSCLIE,
               M.CDCONSUMIDOR, C.NMCONSUMIDOR, TRUNC(M.DTMOVCLI) AS DTMOVCLI, C.VRPESUBCONS, 
               MAX(M.DTMOVCLI) AS MAXDTMOVCLI,
               TRUNC(SUM(NVL((DECODE(M.NRSEQVENDA,NULL,0,DECODE(M.IDTIPMOCVLI,'D',(-1)*M.VRMOVCLI))), 0)), 2) AS VRMOVCLICONSUMO,
               TRUNC(SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVCLI,DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVCLI,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVCLI,0)))), 2) AS VRMOVCLIOUTR,
               TRUNC(SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVCLI,0)), 2) AS VRCREDITOS,
               TRUNC(SUM(DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVCLI,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVCLI,0))), 2) AS VRAJUSTEDEBITOS,
               TRUNC(SUM(NVL((DECODE(M.NRSEQVENDA,NULL,0,DECODE(M.IDTIPMOCVLI,'D',(-1)*M.VRMOVPESCONS))), 0)), 2) AS VRMOVPESCONSUMO,
               TRUNC(SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVPESCONS,DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVPESCONS,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVPESCONS,0)))), 2) AS VRMOVPESOUTR,
               TRUNC(SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVPESCONS)), 2) AS VRCREDITOSPES,
               TRUNC(SUM(DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVPESCONS,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVPESCONS,0))), 2) AS VRAJUSTEDEBPES
        FROM CCUSCLIE D, CLIENFILIAL F, CLIENTE CL, CONSUMIDOR C, MOVICLIE M , CAIXA CX
        WHERE (F.CDFILIAL     =  :CDFILIAL)    AND
              (M.CDFILIAL   = CX.CDFILIAL (+) ) AND 
              (M.CDCAIXA    = CX.CDCAIXA  (+)) AND 
              ((INSTR( :CDCLIENTE, M.CDCLIENTE) > 0) OR ( :TCDCLIENTE = 'T')) AND
              ((INSTR( :CDCONSUMIDOR, M.CDCLIENTE||M.CDCONSUMIDOR) <> 0) OR ( :TCDCONSUMIDOR = 'T')) AND
              ((INSTR( :CDLOJA, M.CDFILIAL||CX.CDLOJA) <> 0) OR ( :TCDLOJA = 'T')) AND
              ((INSTR( :CDTIPOCONS,   C.CDTIPOCONS  ) <> 0) OR ( :TCDTIPOCONS = 'T'  )) AND
              (M.DTMOVIMCLIE BETWEEN  :DTLANCINI AND :DTLANCFIN) AND
              (M.CDCLIENTE    = F.CDCLIENTE)    AND
              (M.CDCLIENTE    = CL.CDCLIENTE)   AND
              (M.CDCLIENTE    = D.CDCLIENTE)    AND
              (C.CDCCUSCLIE   = D.CDCCUSCLIE)   AND
              (C.CDCLIENTE    = M.CDCLIENTE) AND
              (C.CDCONSUMIDOR = M.CDCONSUMIDOR)          
        GROUP BY M.CDCLIENTE, CL.NRINSJURCLIE, CL.IDTPIJURCLIE, CL.NMFANTCLIE,C.CDCCUSCLIE,D.NMCCUSCLIE,
                 M.CDCONSUMIDOR, C.NMCONSUMIDOR, TRUNC(M.DTMOVCLI), C.VRPESUBCONS) A
    WHERE M.CDCLIENTE    = A.CDCLIENTE
      AND M.CDCONSUMIDOR = A.CDCONSUMIDOR
      AND M.DTMOVCLI = A.MAXDTMOVCLI
    ORDER BY M.CDCLIENTE, A.CDCCUSCLIE, M.CDCONSUMIDOR, A.DTMOVCLI
    
    ";
    
    const GET_VRSALDOCONS = "
    SELECT TRUNC(NVL(M.VRSALDOCONS, 0), 2) AS VRSALDOCONS
        FROM (
          SELECT :CDCLIENTE AS CDCLIENTE, :CDCONSUMIDOR AS CDCONSUMIDOR, :MINDTMOVCLI AS DTMOVCLI
          FROM DUAL
        ) D 
        LEFT JOIN MOVICLIE M
          ON D.CDCLIENTE = M.CDCLIENTE
          AND D.CDCONSUMIDOR = M.CDCONSUMIDOR
          AND D.DTMOVCLI = (
            SELECT MAX(DTMOVCLI)
            FROM MOVICLIE
            WHERE CDCLIENTE = :CDCLIENTE
              AND CDCONSUMIDOR = :CDCONSUMIDOR
              AND DTMOVCLI < :MINDTMOVCLI
          )
    ";
    
    const GET_VRSALDPECONS = "
    SELECT TRUNC(NVL(M.VRSALDPECONS, 0), 2) AS VRSALDPECONS
        FROM (
          SELECT :CDCLIENTE AS CDCLIENTE, :CDCONSUMIDOR AS CDCONSUMIDOR, :MINDTMOVCLI AS DTMOVCLI
          FROM DUAL
        ) D 
        LEFT JOIN MOVICLIE M
          ON D.CDCLIENTE = M.CDCLIENTE
          AND D.CDCONSUMIDOR = M.CDCONSUMIDOR
          AND D.DTMOVCLI = (
            SELECT MAX(DTMOVCLI)
            FROM MOVICLIE
            WHERE CDCLIENTE = :CDCLIENTE
              AND CDCONSUMIDOR = :CDCONSUMIDOR
              AND DTMOVCLI < :MINDTMOVCLI
          )
    ";
}